poj 3126 Prime Path(bfs+线性筛)

传送门

题目

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

代码

#include<iostream>
#include<string.h>
#include<queue>
using namespace std;
const int N=10005;
int p[N],ip[N],vis[N],s,e;
void gp()//线性筛求素数 
{
    
    
	for(int i=2;i<=N;i++){
    
    
		if(!p[i]){
    
    
			ip[i]=1;
			for(int j=2;j*i<=N;j++){
    
    
				p[i*j]=1;
			}
		}
	}
}
bool check(int x)
{
    
    
	return !vis[x]&&ip[x];
}
void bfs()
{
    
    
	queue<int> q;
	q.push(s);
	int ans=0;
	while(!q.empty())
	{
    
    
		int n=q.size();
		for(int i=1;i<=n;i++){
    
    
			int cur=q.front();
			vis[cur]=1;
			q.pop();
			if(cur==e){
    
    
				cout<<ans<<endl;
				return;
			}
			for(int i=0;i<=9;i++){
    
    //更换个位 
				int f=cur%10;
				int next=cur-f+i;
				if(check(next)){
    
    
					q.push(next);
				}
			}
			for(int i=0;i<=9;i++){
    
    //更换十位 
				int f=(cur/10)%10;
				int next=cur-f*10+i*10;
				if(check(next)){
    
    
					q.push(next);
				}
			}
			for(int i=0;i<=9;i++){
    
    //更换百位 
				int f=(cur/100)%10;
				int next=cur-f*100+i*100;
				if(check(next)){
    
    
					q.push(next);
				}
			}
			for(int i=1;i<=9;i++){
    
    //更换千位,注意0不能做千位 
				int f=cur/1000;
				int next=cur-f*1000+i*1000;
				if(check(next)){
    
    
					q.push(next);
				}
			}
		}
		ans++;
	}
	cout<<"Impossible"<<endl;
}
int main()
{
    
    
	gp();
	/*for(int i=1000;i<=10000;i++){
		if(ip[i]) cout<<i<<endl;
	}*/
	int t;
	cin>>t;
	while(t--)
	{
    
    
		memset(vis,0,sizeof(vis));
		cin>>s>>e;
		bfs();
	}
	return 0;
} 
/*
3
1033 8179
1373 8017
1033 1033
*/

总结:

很有意思的bfs题

猜你喜欢

转载自blog.csdn.net/Lzhzl211/article/details/114893786